/*
 * IAF_Platform.h
 *
 * Platform-dependent definitions for APIs exported by the IAF core library
 * and imported by the IAF from transport and codec plugin libraries.
 *
 * $Copyright(c) 2002-2004, 2008 Progress Software Corporation (PSC). All rights reserved.$
 * $Copyright (c) 2013-2018 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 *
 * $Revision: 340684 $
 */

#ifndef IAF_PLATFORM_H
#define IAF_PLATFORM_H


#ifdef _WIN32
/*
 * DLL import/export symbols for Win32 builds.  Everything will work correctly
 * as long as the following symbols are *not* defined when this file is
 * included (These symbols are for Apama internal use only):
 *    AP_IAFCORE_BACKEND
 *    AP_EVENTTRANSPORT_BACKEND
 *    AP_EVENTCODEC_BACKEND
 */
#ifdef AP_IAFCORE_BACKEND
#define AP_IAFCORE_API __declspec(dllexport)
#else
#define AP_IAFCORE_API __declspec(dllimport)
#endif
#define AP_IAFCORE_CALL __stdcall

#ifdef AP_EVENTTRANSPORT_BACKEND
#define AP_EVENTTRANSPORT_API __declspec(dllimport)
#else
#define AP_EVENTTRANSPORT_API __declspec(dllexport)
#endif
#define AP_EVENTTRANSPORT_CALL __stdcall

#ifdef AP_EVENTCODEC_BACKEND
#define AP_EVENTCODEC_API __declspec(dllimport)
#else
#define AP_EVENTCODEC_API __declspec(dllexport)
#endif
#define AP_EVENTCODEC_CALL __stdcall


#elif defined(_APBUILD_UNIX_ALL__) || defined(__unix__)
/*
 * Don't need any of these symbols for UNIX builds
 */
#define AP_IAFCORE_API
#define AP_IAFCORE_CALL

#define AP_EVENTTRANSPORT_CALL
#define AP_EVENTTRANSPORT_API

#define AP_EVENTCODEC_CALL
#define AP_EVENTCODEC_API


#else

#error "Can't determine platform: try #define _APBUILD_WIN32_ALL__ or _APBUILD_UNIX_ALL__"

#endif


#endif  /* IAF_PLATFORM_H */

